
#ifndef OEM_SERVICE_H
#define OEM_SERVICE_H

typedef union
{
    uint8_t flags;
    struct
    {
        unsigned Service_1ms    : 1;
        unsigned reserved       : 7;
    };
} Service_Flag;

typedef union
{
    uint8_t flags;
    struct
    {
        unsigned remote_wakeup  : 1;
        unsigned factory_mode   : 1;
        unsigned reserved       : 6;
    };
} System_Flag;


extern volatile Service_Flag  ServiceFlags;
extern volatile System_Flag  system_flag;

void OEM_main_service(void);
void Hook_Timer1msEvent(void);
void Hook_Timer5msEvent(void);
void Hook_Timer10msEventA(void);
void Hook_Timer10msEventB(void);
void Hook_Timer50msEventA(void);
void Hook_Timer50msEventB(void);
void Hook_Timer50msEventC(void);
void Hook_Timer100msEventA(void);
void Hook_Timer100msEventB(void);
void Hook_Timer100msEventC(void);
void Hook_Timer500msEventA(void);
void Hook_Timer500msEventB(void);
void Hook_Timer500msEventC(void);
void Hook_Timer1SecEventA(void);
void Hook_Timer1SecEventB(void);
void Hook_Timer1SecEventC(void);
void Hook_Timer1MinEvent(void);

#endif // OEM_SERVICE_H
