
#include "hal_defs.h"
#include "hal_mcu.h"
#include "OEM_Service.h"
#include "OEM_Timer.h"

uint8_t Timer_1msCnt;
uint8_t Timer_5msCnt;
uint8_t Timer_100msCnt;
uint8_t Timer_100msCntB;
uint8_t Timer_1SecCnt;
uint8_t Timer_1MinCnt;

void service_1ms(void)
{
    Timer_1msEvent();
    Timer_1msCnt++;
    if(Timer_1msCnt >= 10)
    {
        Timer_1msCnt = 0;
    }
    
    if((Timer_1msCnt%5) == 0)
    {
        Timer_5msEvent();
        Timer_5msCnt++;
        /* 10ms events */
        if ( Timer_5msCnt & 1 )
        {
            Timer_10msEventA();
        }
        else
        {
            Timer_10msEventB();
            /* Share Loading Branch Control */
						switch( Timer_5msCnt )
            {
       	        case 2: Timer_50msEventA();
                    break;
          	    case 4: Timer_50msEventB();
             	    break;
        	    case 6: Timer_50msEventC();
              	    break;
          	    case 8: Timer_100msCntB++;
         	        if ( Timer_100msCntB & 1 )
             	    {
                  	    Timer_100msEventA();
              	    }
             	    else
             	    {
                   	    Timer_100msEventB();
              	    }
               	    break;
                    
           	    default:        
                    Timer_5msCnt = 0;
              	    break;
     	    }
            
          if ( Timer_5msCnt == 0 )
    	    {   /* 50msec */
          	    Timer_100msCnt++;
          	    if ( Timer_100msCnt & 1 )
                {
                    Timer_100msEventC();
          	    }
                else
     	        {   /* 100msec */
          	        switch( Timer_100msCnt )
              	    {
                        case 2:	Timer_500msEventA();
                            break;
                        case 4:	Timer_500msEventB();
                      	    break;
                        case 6:	Timer_500msEventC();
                     	    break;
                 	    case 8:	Timer_1SecEventA();
                            break;
                        case 10: Timer_1SecEventB();
                            break;
                        case 12: Timer_500msEventA();
                            break;
                        case 14: Timer_500msEventB();
                            break;
               	        case 16: Timer_500msEventC();
                            break;
                        case 18: Timer_1SecEventC();
                            break;
                        default: 
                            /* 1 Sec */
                            Timer_100msCnt = 0;
                  	        Timer_1SecCnt++;
                            if ( Timer_1SecCnt == 60 )
                      	    {
                                Timer_1MinEvent();
                                Timer_1SecCnt = 0;
                            }
                            break;
          	        }
              	}
       	    }
   	    }
    } 
}

/**
 * ****************************************************************************
 * 1ms events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_1msEvent(void)
{
    Hook_Timer1msEvent();
}

/**
 * ****************************************************************************
 * 5ms events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_5msEvent(void)
{
    Hook_Timer5msEvent();
}

/**
 * ****************************************************************************
 * 10ms A events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_10msEventA(void)
{
    Hook_Timer10msEventA();	
}

/**
 * ****************************************************************************
 * 10ms B events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_10msEventB(void)
{
    Hook_Timer10msEventB();	 
}

/**
 * ****************************************************************************
 * 50ms A events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_50msEventA(void)
{
    Hook_Timer50msEventA();
}

/**
 * ****************************************************************************
 * 50ms B events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_50msEventB(void)
{
    Hook_Timer50msEventB();
}

/**
 * ****************************************************************************
 * 50ms C events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_50msEventC(void)
{
    Hook_Timer50msEventC();
}

/**
 * ****************************************************************************
 * 100ms A events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_100msEventA(void)
{
    Hook_Timer100msEventA();
}

/**
 * ****************************************************************************
 * 100ms B events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_100msEventB(void)
{
    Hook_Timer100msEventB();
}

/**
 * ****************************************************************************
 * 100ms C events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_100msEventC(void)
{
    Hook_Timer100msEventC();
}

/**
 * ****************************************************************************
 * 500ms A events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_500msEventA(void)
{
    Hook_Timer500msEventA();
}

/**
 * ****************************************************************************
 * 500ms B events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_500msEventB(void)
{
    Hook_Timer500msEventB();
}

/**
 * ****************************************************************************
 * 500ms C events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_500msEventC(void)
{
    Hook_Timer500msEventC();
}

/**
 * ****************************************************************************
 * 1sec A events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_1SecEventA(void)
{	
    Hook_Timer1SecEventA();
}

/**
 * ****************************************************************************
 * 1sec B events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_1SecEventB(void)
{
    Hook_Timer1SecEventB();
}

/**
 * ****************************************************************************
 * 1sec C events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_1SecEventC(void)
{
    Hook_Timer1SecEventC();
}

/**
 * ****************************************************************************
 * 1min events
 *
 * @return
 *
 * @parameter
 *
 * ****************************************************************************
 */
void Timer_1MinEvent(void)
{
    Hook_Timer1MinEvent();
}

