/******************************************************************************

    Filename: fw_usb_hooks.h

******************************************************************************/
#ifndef FW_USB_HOOKS_H
#define FW_USB_HOOKS_H


/******************************************************************************
 * INCLUDES
 */




/******************************************************************************
 * FUNCTIONS
 */

// These function are all the featured USB hooks offered by the bootloader.
// If they are not needed and thus not implemented, make sure the
// APPLICATION_DESCRIPTOR in fw_app_descriptor.c has NULL pointers. Then they
// will not be called from the bootloader.

void usbVrHookProcessIn(void);         // Vendor requests, IN
void usbVrHookProcessOut(void);        // Vendor requests, OUT
void usbCrHookProcessIn(void);         // Class requests, IN
void usbCrHookProcessOut(void);        // Class requests, OUT
void usbSrHookClearFeature(void);      // Standard request: Clear feature
void usbSrHookSetFeature(void);        // Standard request: Set feature
void usbSrHookProcessEvents(uint8 event, uint8 epIndex);// Process events from standard requests
void usbIrqHookProcessEvents(void);    // Process events in interrupt context


/*****************************************************************************/
#endif
