/*
 * OEM_ColorTypeDef.h
 *
 *  Created on: 2018~18
 *      Author: Sean1_Cheng
 */

#ifndef OEM_COLORTYPEDEF_H_
#define OEM_COLORTYPEDEF_H_

typedef struct
{
    uint8_t r;
    uint8_t g;
    uint8_t b;
} RgbColor;

typedef struct
{
    uint8_t h;
    uint8_t s;
    uint8_t v;
} HsvColor;

#define EFFECT_GROUP  4 
typedef struct frame{
    uint8_t GROUP_INDEX;
    uint8_t Mode[EFFECT_GROUP];
    uint8_t Speed[EFFECT_GROUP];
    uint8_t Random[EFFECT_GROUP];
    uint8_t Direction;
    uint8_t Lightness[EFFECT_GROUP];
    uint16_t tick[EFFECT_GROUP];
    uint16_t Frame_Index;
    HsvColor Hsv[EFFECT_GROUP];
    RgbColor Color[EFFECT_GROUP];
    RgbColor ColorLevel1[EFFECT_GROUP];
    uint8_t Low_Battery_Alarm_Threshold;
    uint8_t Force_tick;
    RgbColor Force_Color;
    bool Forced;
    uint8_t Force_Effect_Mode;
    RgbColor *Draw_Space;
}frame_t;

#endif /* OEM_COLORTYPEDEF_H_ */
