
#ifndef OEM_SERVICE_H
#define OEM_SERVICE_H

#include "OEM_TypeDef.h"
#include <ti/sysbios/knl/Event.h>

void hw_delay_5us(uint32_t Delay_Time);
void sw_delay_1us(uint32_t Delay_Time);
void start_oem_service_clock(void);
void stop_oem_service_clock(void);
void MainService_createTask( void );
void PowerOffService_createTask(void);
void GPTImer_Initial(void);
void GPTimer_DeInit(void);
void service_1ms( void );
void Hook_Timer1msEvent( void );
void Hook_Timer5msEvent( void );
void Hook_Timer10msEventA( void );
void Hook_Timer10msEventB( void );
void Hook_Timer50msEventA( void );
void Hook_Timer50msEventB( void );
void Hook_Timer50msEventC( void );
void Hook_Timer100msEvent( void );
void Hook_Timer500msEventA( void );
void Hook_Timer500msEventB( void );
void Hook_Timer500msEventC( void );
void Hook_Timer1SecEventA( void );
void Hook_Timer1SecEventB( void );
void Hook_Timer1SecEventC( void );
void Hook_Timer1MinEvent( void );

extern Event_Handle serviceEvent;
    #define OEM_SERVICE_UART_EVENT          Event_Id_00
    #define OEM_SERVICE_1MS_EVENT           Event_Id_01
    #define OEM_PAIRING_DONE_EVENT          Event_Id_03
    #define OEM_PAIRING_START_EVENT         Event_Id_04
    #define OEM_RF_PAIRING_TIMEOUT          Event_Id_05
    #define OEM_SLEEP_MODE_EVENT            Event_Id_07
    #define OEM_I2C_RESULT_SUCCESS_EVT      Event_Id_08
    #define OEM_I2C_RESULT_FAIL_EVT         Event_Id_09
    #define OEM_RF_BER_EVENT                Event_Id_10
    #define OEM_FORCE_SLEEP_ENTRY_EVENT     Event_Id_11
    #define OEM_FORCE_SLEEP_DONE_EVENT      Event_Id_12
    #define OEM_SERVICE_GPIO_WAKEUP_EVENT   Event_Id_31
    #define OEM_SERVICE_WAIT_EVENT          ((OEM_SERVICE_UART_EVENT)    |\
                                            (OEM_SERVICE_1MS_EVENT)      |\
                                            (OEM_RF_PAIRING_TIMEOUT)     |\
                                            (OEM_PAIRING_START_EVENT)    |\
                                            (OEM_PAIRING_DONE_EVENT)     |\
                                            (OEM_SLEEP_MODE_EVENT)       |\
                                            (OEM_I2C_RESULT_SUCCESS_EVT) |\
                                            (OEM_I2C_RESULT_FAIL_EVT)    |\
                                            (OEM_RF_BER_EVENT)           |\
                                            (OEM_FORCE_SLEEP_ENTRY_EVENT)|\
                                            (OEM_SERVICE_GPIO_WAKEUP_EVENT)|\
                                            (OEM_FORCE_SLEEP_DONE_EVENT))
    #define OEM_SERVICE_SLEEP_EVENT        ((OEM_SERVICE_GPIO_WAKEUP_EVENT))

extern DWORD device_mode;
    #define BLE_MODE        BIT0
    #define RF_MODE         BIT1
    #define USB_MODE        BIT2

#define Set_USB_Mode()      do{ (device_mode |= (USB_MODE)); } while(0)
#define Set_RF_Mode()       do{ (device_mode |= (RF_MODE)); } while(0)
#define Set_BLE_Mode()      do{ (device_mode |= (BLE_MODE)); } while(0)

#define Is_USB_Mode()       (device_mode & (USB_MODE))
#define Is_RF_Mode()        (device_mode & (RF_MODE))
#define Is_BLE_Mode()       (device_mode & (BLE_MODE))
#define Is_USB_Mode_Only()  ((device_mode & (USB_MODE|RF_MODE|BLE_MODE)) == (USB_MODE))
#define Is_RF_Mode_Only()   ((device_mode & (USB_MODE|RF_MODE|BLE_MODE)) == (RF_MODE))
#define Is_BLE_Mode_Only()  ((device_mode & (USB_MODE|RF_MODE|BLE_MODE)) == (BLE_MODE))
#define Is_USB_RF_Mode()    (device_mode & (USB_MODE|RF_MODE))
#define Is_USB_BLE_Mode()   (device_mode & (USB_MODE|BLE_MODE))
#define Is_OFF_Mode()       ((device_mode & (USB_MODE|RF_MODE|BLE_MODE)) == 0x0000)
#define Is_Wireless_Mode()  (!Is_USB_Mode())

#endif // OEM_SERVICE_H
