/*
*	OEM_TRNG.C
*
*   OEM TRNG related functions.
*
*	Author: Sean Cheng - Asus
*	email: sean1_cheng@asus.com
*
*/
/* Board Header files */
#include "Board.h"
#include "OEM_Include.h"

TRNGCC26XX_Handle TRNG_handle;

void OEM_TRNG_Init(void)
{
    TRNGCC26XX_init();
    TRNGCC26XX_Params_init(NULL);

    /* Try open the SPI */
    TRNG_handle = TRNGCC26XX_open(NULL);
    if ( TRNG_handle == NULL ) {
        DBG_puts_Log( "TRNG_Err" );
    } else {
        DBG_puts_Log( "TRNG_Init" );
    }
}

void OEM_TRNG_DeInit(void)
{
    TRNGCC26XX_close(TRNG_handle);
}

uint32_t Get_Random_Number(void)
{
    uint32_t rand_value;

    OEM_TRNG_Init();
    rand_value = TRNGCC26XX_getNumber(TRNG_handle,NULL,0);
    OEM_TRNG_DeInit();

    return rand_value;
}