/*
*	OEM_WDT.C
*
*   OEM watchdog related functions.
*
*	Author: Hugo Lin - Asus
*	email: Hugo_Lin@asus.com
*
*/

/* Board Header files */
#include "Board.h"
#include "OEM_Include.h"

#define WDT_ENABLE          0

#if WDT_ENABLE == 1
static Watchdog_Handle watchdogHandle;

void oem_watchdog_init(void)
{
    Watchdog_Params params;

    /* Call board init functions */
    Watchdog_init();

    /* Create and enable a Watchdog with resets disabled */
    Watchdog_Params_init(&params);
    //params.callbackFxn = (Watchdog_Callback)watchdogCallback;
    params.resetMode = Watchdog_RESET_ON;
    watchdogHandle = Watchdog_open(CC2640R2RC_WATCHDOG0 , &params);

    if ( watchdogHandle == NULL ) {
        DBG_puts_Log("WDTfail");
    } else {
        DBG_puts_Log("WDTinit");
    }
}

void oem_clear_watchdog(void)
{
    /* Clear watchdog interrupt flag */
    Watchdog_clear(watchdogHandle);
}
#else
void oem_watchdog_init(void)
{

}

void oem_clear_watchdog(void)
{

}
#endif

