/*
*	OEM_dbg.C
*
*   OEM debug related functions.
*
*	Author: Hugo Lin - Asus
*	email: Hugo_Lin@asus.com
*
*/

#include <stdlib.h>
#include <xdc/std.h>

/* Board Header files */
#include "Board.h"
#include "OEM_Include.h"

void DBG_char(unsigned char b)
{
    uart_send_fifo(b);
}

void DBG_write(unsigned char b)
{
	unsigned char ch;
	unsigned char j;
	j=b>>4;					//MSb[7:4]
	b&=0x0F;				//LSb[3:0]
	
	if (j>0x09) 
	{
		ch = j+0x37;
	} 
	else
	{
		ch = j+0x30;
	}
	DBG_char(ch);
	
	if (b>0x09)
	{
		ch = b+0x37;
	}
	else
	{
		ch = b+0x30;
	}
	DBG_char(ch);
}

void DBG_byte(unsigned char b)
{
	DBG_write(b);
	DBG_char(',');
}

void DBG_word(unsigned int w)
{
	DBG_write((unsigned char)(w>>8));
	DBG_write((unsigned char) w);
	DBG_char(',');
}

void DBG_dword(uint32_t dw)
{
	DBG_write((unsigned char)(dw>>24));
	DBG_write((unsigned char)(dw>>16));
	DBG_write((unsigned char)(dw>>8));
	DBG_write((unsigned char) dw);
	DBG_char(',');
}

void DBG_puts(const char* s)
{
	while(*s)
	{
		DBG_char(*s);
		s++;
	}
	DBG_char('\n');
}
