/******************************************************************************
*  Filename:       rf_patch_cpe_hid.h
*  Revised:        $Date$
*  Revision:       $Revision$
*
*  Description:    RF Core patch file for CC26xx R2
*
*  Copyright (c) 2015, Texas Instruments Incorporated
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions are met:
*
*  1) Redistributions of source code must retain the above copyright notice,
*     this list of conditions and the following disclaimer.
*
*  2) Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*
*  3) Neither the name of the ORGANIZATION nor the names of its contributors may
*     be used to endorse or promote products derived from this software without
*     specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************/

#ifndef _RF_PATCH_CPE_HID_H
#define _RF_PATCH_CPE_HID_H

//*****************************************************************************
//
// If building with a C++ compiler, make all of the definitions in this header
// have a C binding.
//
//*****************************************************************************
#ifdef __cplusplus
extern "C"
{
#endif

#include <stdint.h>
#include <string.h>

#ifndef CPE_PATCH_TYPE
#define CPE_PATCH_TYPE static const uint32_t
#endif

#ifndef SYS_PATCH_TYPE
#define SYS_PATCH_TYPE static const uint32_t
#endif

#ifndef PATCH_FUN_SPEC
#define PATCH_FUN_SPEC static inline
#endif

#ifndef _APPLY_PATCH_TAB
#define _APPLY_PATCH_TAB
#endif


CPE_PATCH_TYPE patchImageHid[] = {
   0x21000c07,
   0x4cfcb510,
   0x28007b20,
   0xf000d00c,
   0x49fafbe4,
   0x47882001,
   0x1e407b20,
   0x8a617320,
   0x18406ae0,
   0x200162e0,
   0xb5febd10,
   0x4cf24bf4,
   0x07c06a18,
   0x2000d077,
   0x69a59000,
   0x46074602,
   0x63584601,
   0x7c4648ef,
   0x2e104630,
   0x210fd905,
   0x6a9a6319,
   0x1a702110,
   0x2800b2c0,
   0x1e40d021,
   0x6a986318,
   0x40884fe8,
   0x68fa4310,
   0x47904631,
   0x46306939,
   0x21274788,
   0x09095d09,
   0xd00d07c9,
   0xd00b2d00,
   0x1b892120,
   0xba004088,
   0xe0032100,
   0x1c6d7028,
   0x31080a00,
   0xdbf942b1,
   0x478048db,
   0x2d004607,
   0x4620d023,
   0x79c13020,
   0x07c90949,
   0x7981d002,
   0x1c6d7029,
   0x098979c1,
   0xd00907c9,
   0x01fa7903,
   0x2b002101,
   0x2100d000,
   0x430a0189,
   0x1c6d702a,
   0x09c079c0,
   0x6ba0d008,
   0x0a017028,
   0x0c017069,
   0x0e0070a9,
   0x1d2d70e8,
   0x200061a5,
   0x90014626,
   0x6b203620,
   0x28007975,
   0x49c4d01c,
   0xd0072f00,
   0x085279f2,
   0xd00307d2,
   0xd00b2d00,
   0xe00b2500,
   0x2a007932,
   0x79f2d102,
   0xd1f507d2,
   0xd00f2d00,
   0xe057e002,
   0x90004788,
   0x07409800,
   0x2001d502,
   0x900105c0,
   0xd0062d00,
   0x05802001,
   0xe00e2104,
   0x39b449b2,
   0x2f00e7ee,
   0x2001d003,
   0x21020440,
   0x7930e005,
   0xd0142800,
   0x04002001,
   0x9b012101,
   0x6b604303,
   0xd0062800,
   0x1c525c42,
   0x79b15442,
   0x6ba171c1,
   0x48a66081,
   0x2d006083,
   0x48a5d005,
   0x2001e018,
   0x21030480,
   0x48a3e7e9,
   0x48a34780,
   0x4aa37ac0,
   0xd0102f00,
   0xd00107c0,
   0xe00a6062,
   0xff2ef7ff,
   0xd0032800,
   0x6020489e,
   0xbdfe2000,
   0x1e80489b,
   0x20036060,
   0x7a61bdfe,
   0x1c494b97,
   0x0f890789,
   0x681b3b20,
   0x755907c0,
   0x2055d1e6,
   0xe7ef0280,
   0x20044994,
   0x20016008,
   0xb5f8bdfe,
   0x24004e84,
   0x30204630,
   0x79009000,
   0x69b569f1,
   0x48821a47,
   0x63441e7f,
   0xdd1a2f00,
   0x6301210f,
   0x6a80e011,
   0x688a497f,
   0x47902110,
   0x6901487d,
   0x47882010,
   0xd0052d00,
   0x55290a01,
   0x55281c64,
   0xe0001c64,
   0x48751ca4,
   0x07896b81,
   0x42bcd501,
   0x42bcdbe7,
   0x4871d112,
   0x63012107,
   0x07896b81,
   0x6a80d50c,
   0x688a496f,
   0x47902108,
   0x6901486d,
   0x47882008,
   0xd0002d00,
   0x1c645528,
   0xd0012d00,
   0x61b01928,
   0xdd0842bc,
   0x30b04867,
   0x99004780,
   0x486e7188,
   0x20006030,
   0x69f0bdf8,
   0x61f11901,
   0x485f9a00,
   0x30207912,
   0x1a517b00,
   0x428100c9,
   0x4608da00,
   0x63484959,
   0x20104965,
   0x49626008,
   0x20016008,
   0xb5f8bdf8,
   0x49624c52,
   0x30384620,
   0x4f5c4788,
   0xd00b2800,
   0x47804857,
   0x7ac04857,
   0xd5650740,
   0xfe9cf7ff,
   0xd0382800,
   0xe05d6027,
   0x46252000,
   0x61e03520,
   0x71684e48,
   0x7a206370,
   0x07c00900,
   0x2007d010,
   0x6bb06330,
   0xd5fc0780,
   0x49446ab0,
   0x2108688a,
   0x48424790,
   0x20086901,
   0x7ae14788,
   0xd1dd4281,
   0x1e407b60,
   0x6bb06330,
   0xd5fc0780,
   0x7b614839,
   0x4e3a6a80,
   0x479068b2,
   0x7b606931,
   0x46064788,
   0x08807a20,
   0xd00907c0,
   0x0e000570,
   0x7a697128,
   0xd8c34288,
   0x4838e004,
   0xe0101ec0,
   0x71282000,
   0x7ba07929,
   0x184100c9,
   0x6141482a,
   0x63c12101,
   0xfa46f000,
   0x42082121,
   0x204bd004,
   0x606002c0,
   0xbdf82003,
   0x280069a0,
   0x79e9d00a,
   0x07c908c9,
   0x10f1d005,
   0x07717001,
   0x70410f49,
   0x61a01c80,
   0x6020482b,
   0xbdf82000,
   0xbdf82001,
   0x4829b57c,
   0x47804c16,
   0xd1272800,
   0x47804827,
   0x20004918,
   0x478839cc,
   0x20004913,
   0x48246348,
   0x48124780,
   0x78804a13,
   0x6be13a36,
   0x48164790,
   0x22fb7ac1,
   0x72c14011,
   0x22042300,
   0x9301480b,
   0x30a09200,
   0x6ba18a00,
   0x180a4d1a,
   0x46182182,
   0x481647a8,
   0x47803084,
   0x60204817,
   0xbd7c2001,
   0x21000144,
   0x00007259,
   0x40045040,
   0x21000028,
   0x21000300,
   0x00005a8b,
   0x00003963,
   0x40041100,
   0x00005801,
   0x00000b69,
   0x2100010c,
   0x00005405,
   0x21000a51,
   0xe000e100,
   0x21000473,
   0xe000e280,
   0x00006a9f,
   0x2100062b,
   0x000067c7,
   0x00005083,
   0x00006933,
   0x00000c89,
   0x210006f3,
   0x48fcb570,
   0x6a004cfa,
   0xd03507c0,
   0x478048fa,
   0x201049fa,
   0x6b606088,
   0xd0022800,
   0x1c497801,
   0x7a207001,
   0x07c00840,
   0x7aa0d002,
   0xd0052800,
   0x7ac048f3,
   0xd01a07c0,
   0xe01a48f2,
   0x5d002028,
   0x00c07be1,
   0x48f01809,
   0x8cc08dc2,
   0x6ae24351,
   0x18100909,
   0x49ed180d,
   0x47882000,
   0x21004aec,
   0x47904628,
   0x63a548eb,
   0x20006020,
   0x2055bd70,
   0x60600280,
   0xbd702002,
   0x780148e7,
   0x00490849,
   0x49e67001,
   0x60082004,
   0xbd702001,
   0x4cd8b570,
   0x4dd8262f,
   0x636e0236,
   0x2810e019,
   0x200fd301,
   0x1e40e000,
   0x49d862e8,
   0x7c497c20,
   0xd0014288,
   0xe0036a20,
   0x690949d8,
   0x62204788,
   0x7c206268,
   0xd91a2810,
   0x0c096a21,
   0x62213810,
   0x7c207420,
   0xd0142800,
   0x07c96ba9,
   0x6ba8d1df,
   0x42082114,
   0x48c9d0d9,
   0x7b403020,
   0x63680200,
   0x200849cc,
   0x49ca6008,
   0x20016008,
   0x2000bd70,
   0x48c97420,
   0x20006020,
   0xb5f8bd70,
   0x4eba202f,
   0x02004cb8,
   0x4fc16370,
   0x07c06bb0,
   0x200fd01e,
   0x69a562f0,
   0xe01369e0,
   0xdd2a2801,
   0x46687829,
   0x78697041,
   0x1cad7001,
   0x880068ba,
   0x47902110,
   0x20106939,
   0xb2804788,
   0x69e06270,
   0x61e01e80,
   0xdd022800,
   0x07c96bb1,
   0x61a5d1e6,
   0x280069e0,
   0x6bb0dd1f,
   0x42082114,
   0x48a8d0d6,
   0x7b403020,
   0x63700200,
   0x200849ab,
   0x49a96008,
   0x20016008,
   0x7828bdf8,
   0x70084669,
   0x68ba1c6d,
   0x47902108,
   0x62f02007,
   0x20086939,
   0x62704788,
   0x61e02000,
   0x4d9ae7db,
   0x7c6968fa,
   0x47902000,
   0x74207c68,
   0x6020489e,
   0xbdf82000,
   0x4892b510,
   0x38204c8d,
   0x4a946800,
   0x6ae02101,
   0x49994790,
   0x47882000,
   0x20074989,
   0x499762c8,
   0x47882001,
   0x4a95488b,
   0x32967880,
   0x47906be1,
   0x30764891,
   0x7a204780,
   0x17c00780,
   0x72a01c40,
   0x61a06960,
   0x09c07a20,
   0xf940f000,
   0x6020488c,
   0xbd102000,
   0x4e7db570,
   0x3e204c78,
   0x49816835,
   0x5e082006,
   0xd0091c41,
   0xd0072801,
   0x78004885,
   0xd0062803,
   0x60604884,
   0xbd702002,
   0x1e404882,
   0x4975e7f9,
   0x47882001,
   0x72207ba8,
   0x7be94620,
   0x71c13020,
   0x72017de9,
   0x63e16929,
   0x616169e9,
   0x72617d69,
   0x72e17d29,
   0x72417da9,
   0x73207e28,
   0x82608b68,
   0x63206a28,
   0x63606a68,
   0x7a224d65,
   0x200a78e9,
   0x07d208d2,
   0x2009d100,
   0x7c6a7360,
   0x7a201882,
   0x07c00900,
   0x2008d000,
   0x070a1810,
   0x09090f12,
   0x1c491c52,
   0x434a73a0,
   0x185178a9,
   0x73e01808,
   0x20084965,
   0x22004788,
   0x4b544620,
   0x4611303c,
   0x4798339e,
   0x60204861,
   0x8c296a30,
   0x62e01840,
   0xbd702000,
   0x484cb570,
   0x7ac04c47,
   0xd5030780,
   0x2503485b,
   0xe0116060,
   0x360126ff,
   0x46304956,
   0x68204788,
   0xd1012800,
   0x60204856,
   0x00054780,
   0xd0fb6820,
   0x46304950,
   0x47883912,
   0x78404844,
   0xd0102800,
   0x6b804839,
   0xd5060741,
   0x68094941,
   0xd5020709,
   0x1c804847,
   0x0680e003,
   0x4845d503,
   0x60601c40,
   0x2d03e004,
   0x2d02d002,
   0xbd70d008,
   0xf825f000,
   0x280069a0,
   0x4943d002,
   0x47886b20,
   0x07c07a20,
   0x482dd002,
   0x47803056,
   0x2000493f,
   0x68604788,
   0x02014b3e,
   0xb2800e09,
   0x47982200,
   0x8800bd70,
   0x1840493b,
   0x2082d001,
   0x48224770,
   0x38202140,
   0x49388501,
   0x20016241,
   0xb5104770,
   0x47804836,
   0x4780481a,
   0x20004930,
   0xbd104788,
   0x4a15b570,
   0x46142000,
   0x79e33420,
   0x08dd7921,
   0xd00007ed,
   0x091d1c89,
   0xd00407ed,
   0x7c6d4d14,
   0x08ed1ded,
   0x095d1869,
   0xd00007ed,
   0x099d1c49,
   0xd00007ed,
   0x09db1c49,
   0x1d09d000,
   0x25006b13,
   0xd0492b00,
   0x4b224618,
   0x47983218,
   0x42082123,
   0x2101d040,
   0xe0407161,
   0x21000144,
   0x40045040,
   0x00005301,
   0x40041100,
   0x2100010c,
   0x00005405,
   0x21000028,
   0x00007259,
   0x00006657,
   0x210007e1,
   0x21000300,
   0xe000e100,
   0xe000e280,
   0x2100089d,
   0x21000929,
   0x00004fb3,
   0x000059bf,
   0x210009a3,
   0x2100028c,
   0x00025803,
   0x00003fd1,
   0x21000a51,
   0x00025406,
   0x21000aa5,
   0x00003963,
   0x00000e03,
   0x00000543,
   0xffffa7ff,
   0x21000b69,
   0x00006d1d,
   0x000034f3,
   0xe0007165,
   0x07416195,
   0x2101d503,
   0x05c94a20,
   0xbd706091,
   0x202fb5f1,
   0x4c1e4d1f,
   0x63680200,
   0x36204626,
   0x61e07a30,
   0x4f1c7a20,
   0x07c00900,
   0x68bad007,
   0x21087ae0,
   0x69394790,
   0x47882008,
   0x7a206268,
   0x06407a31,
   0x0f807a62,
   0x69a3d00c,
   0x61a61c5e,
   0x07c6781b,
   0x07ded002,
   0x72a60ff6,
   0xd5010780,
   0x0f820758,
   0x28009800,
   0x2133d000,
   0x0f400790,
   0x430800c9,
   0x68ba7aa1,
   0x7b614308,
   0x7b604790,
   0x62e91e41,
   0x47886939,
   0xbdf86268,
   0x40041100,
   0x21000144,
   0x40045040,
   0x21000300,
};
#define _NWORD_PATCHIMAGE_HID 600

#define _NWORD_PATCHSYS_HID 0



#ifndef _HID_SYSRAM_START
#define _HID_SYSRAM_START 0x20000000
#endif

#ifndef _HID_CPERAM_START
#define _HID_CPERAM_START 0x21000000
#endif

#define _HID_SYS_PATCH_FIXED_ADDR 0x20000000

#define _HID_PARSER_PATCH_TAB_OFFSET 0x0350
#define _HID_PATCH_TAB_OFFSET 0x0358
#define _HID_IRQPATCH_OFFSET 0x03E8
#define _HID_PATCH_VEC_OFFSET 0x0448

PATCH_FUN_SPEC void enterHidCpePatch(void)
{
   uint32_t *pPatchVec = (uint32_t *) (_HID_CPERAM_START + _HID_PATCH_VEC_OFFSET);

#if (_NWORD_PATCHIMAGE_HID > 0)
   memcpy(pPatchVec, patchImageHid, sizeof(patchImageHid));
#endif
}

PATCH_FUN_SPEC void enterHidSysPatch(void)
{
}

PATCH_FUN_SPEC void configureHidPatch(void)
{
   uint8_t *pParserPatchTab = (uint8_t *) (_HID_CPERAM_START + _HID_PARSER_PATCH_TAB_OFFSET);


   pParserPatchTab[5] = 0;
}

PATCH_FUN_SPEC void applyHidPatch(void)
{
   enterHidSysPatch();
   enterHidCpePatch();
   configureHidPatch();
}

PATCH_FUN_SPEC void refreshHidPatch(void)
{
   enterHidCpePatch();
   configureHidPatch();
}

PATCH_FUN_SPEC void rf_patch_cpe_hid(void)
{
   applyHidPatch();
}


//*****************************************************************************
//
// Mark the end of the C bindings section for C++ compilers.
//
//*****************************************************************************
#ifdef __cplusplus
}
#endif

#endif //  _RF_PATCH_CPE_HID_H

