

//*********************************************************************************
// These settings have been generated for use with TI-RTOS and cc13xxware
//
// Generated by SmartRF Studio version 2.4.3 (build #23) and modified
// Tested for BLE SDK version 1.00.00
// Device: CC2640R2F
//
//*********************************************************************************


//*********************************************************************************
// Default parameter summary
// HID mode
// GFSK 2 Mbps
// Address: ef
// Frequency: 2440.00000 MHz
// Data Format: Serial mode disable
// Deviation: 500.000 kHz
// Packet Length Config: Variable
// Max Packet Length: 128
// Packet Length: 16
// RX Filter BW: 98 kHz
// Symbol Rate: 50.00000 kBaud
// Sync Word Length: 32 Bits
// TX Power: 0 dBm
// Whitening: No whitening

#ifdef DEVICE_FAMILY
    #undef DEVICE_FAMILY_PATH
    #define DEVICE_FAMILY_PATH(x) <ti/devices/DEVICE_FAMILY/x>
#else
    #error "You must define DEVICE_FAMILY at the project level as one of cc26x0, cc26x0r2, cc13x0, etc."
#endif

// Definitions to add new parameter for HID mode:
#define _POSITION_propRadioPar_rxIfsTimeout                     176
#define _TYPE_propRadioPar_rxIfsTimeout                         uint16_t


#include DEVICE_FAMILY_PATH(driverlib/rf_mailbox.h)
#include DEVICE_FAMILY_PATH(driverlib/rf_common_cmd.h)

#include DEVICE_FAMILY_PATH(rf_patches/rf_patch_cpe_prop.h)
#include DEVICE_FAMILY_PATH(rf_patches/rf_patch_rfe_genfsk.h)
#include DEVICE_FAMILY_PATH(rf_patches/rf_patch_mce_genfsk.h)

#include "rf_patch_cpe_hid.h"
#include "rf_hid_cmd.h"
#include "rf_hid_mailbox.h"

#include <ti/drivers/rf/RF.h>
#include "smartrf_settings.h"

// CMD_FS
// Frequency Synthesizer Programming Command
rfc_CMD_FS_t RF_cmdFs =
{
    .commandNo                    = 0x0803,
    .status                       = 0x0000,
    .pNextOp                      = 0,                // INSERT APPLICABLE POINTER: (uint8_t*)&xxx
    .startTime                    = 0x00000000,
    .startTrigger.triggerType     = 0x0,
    .startTrigger.bEnaCmd         = 0x0,
    .startTrigger.triggerNo       = 0x0,
    .startTrigger.pastTrig        = 0x0,
    .condition.rule               = 0x1,
    .condition.nSkip              = 0x0,
    .frequency                    = 0x0988,
    .fractFreq                    = 0x0000,
    .synthConf.bTxMode            = 0x0,
    .synthConf.refFreq            = 0x0,
    .__dummy0                     = 0x00,
    .__dummy1                     = 0x00,
    .__dummy2                     = 0x00,
    .__dummy3                     = 0x0000,
};

// TI-RTOS RF HID Mode Object
RF_Mode RF_HID =
{
    .rfMode                       = RF_MODE_PROPRIETARY_2_4,
    .cpePatchFxn                  = &rf_patch_cpe_hid,
    .mcePatchFxn                  = 0,
    .rfePatchFxn                  = 0,
};

// Overrides
static uint32_t HID_pOverrides[] =
{
    //Overrides (tentative):
    0x01010007,               // MCE_RFE_OVERRIDE(0, 0, 1, 0, 0, 1),                   // Use correct RFE mode
    0x013800C3,               // Set 500 kHz deviation in TX
    0x02080283,               // SW_REG_OVERRIDE(radioPar, rxToTxRatOffset, 0x0208),   // Set IFS (130 us)
    //0x03000283,             // SW_REG_OVERRIDE(radioPar, rxToTxRatOffset, 0x0208),   // Set IFS (130 us)
    0x002482d3,               // SW_REG_BYTE_OVERRIDE(radioPar, txFifoThrSleep, 0x24), // Avoid FIFO underflow in TX
    //0x02ad0b03,             // SW_REG_OVERRIDE(propRadioPar, rxIfsTimeout, 0x02AD),  // Set timeout for ACK
    0x02000b03,               // SW_REG_OVERRIDE(propRadioPar, rxIfsTimeout, 0x02AD),  // Set timeout for ACK
    0xffffffff,               // END_OVERRIDE,                                         // End of string
};

// Radio Setup Command
rfc_CMD_RADIO_SETUP_t cmdHIDRadioSetup =
{
    .commandNo                    = 0x0802,
    .status                       = 0x0000,
    .pNextOp                      = 0,
    .startTime                    = 0x00000000,
    .startTrigger.triggerType     = 0x0,
    .startTrigger.bEnaCmd         = 0x0,
    .startTrigger.triggerNo       = 0x0,
    .startTrigger.pastTrig        = 0x0,
    .condition.rule               = 0x1,
    .condition.nSkip              = 0x0,

    .mode                         = 0x02,             // 0x02: 2 Mbps GFSK
    .config.frontEndMode          = 0x0,
    .config.biasMode              = 0x0,              // 0: Internal bias
    .config.analogCfgMode         = 0x0,
    .config.bNoFsPowerUp          = 0x0,
    .txPower                      = OEM_RF_TX_POWER,
    .pRegOverride                 = HID_pOverrides,
};

// CMD_HID_TX
rfc_CMD_HID_TX_t RF_cmdHIDTx =
{
    .commandNo                    = 0x5801,
    .status                       = 0x0000,
    .pNextOp                      = 0,                // INSERT APPLICABLE POINTER: (uint8_t*)&xxx
    .startTime                    = 0x00000000,
    .startTrigger.triggerType     = TRIG_NOW,
    .startTrigger.bEnaCmd         = 0x0,
    .startTrigger.triggerNo       = 0x0,
    .startTrigger.pastTrig        = 0x1,
    .condition.rule               = COND_NEVER,       // don't run any next command
    .condition.nSkip              = 0x0,

    .pktConf.bFsOff               = 0x0,              // Turn off synth after command.
    .pktConf.bAutoRetransmit      = 1,                // 0: Do not listen for ACK // 1: Listen for ACK and retransmit if missing
    .pktConf.bVarLen              = 0x1,              // 1: Variable length mode
    .pktConf.hdrMode              = 0x0,
    .pktConf.bIncludeAddr         = 0x1,
    .pktConf.hdrConf              = 0x0,
    .pktConf.bFixedTxLen          = 0x0,
    .syncWord                     = TEST_SYNCWORD,    // 0x29417471, //0x29417671
    .address                      = TEST_ADDRESS,     // 0xEF,       // set address
    .seqNo                        = 0x0,
    .maxAckLen                    = 0x20,             // 0x20,
    .pktLen                       = 0x07,             // SET APPLICATION PAYLOAD LENGTH, set in application
    .maxRetrans                   = 0x0,              // 0x1, // 0x02
    .retransDelay                 = 0x5A0,            // 0x5A0 for 360us // 0x800 for 512us //0x4b0 for 300us
    .pPkt                         = 0,                // INSERT APPLICABLE POINTER: (uint8_t*)&xxx
    .pRxQueue                     = 0,                // Pointer to receive queue for ACKs
    .pOutput                      = 0,                // Pointer to output structure
};

// Output struct
rfc_hidRxTxOutput_t output_tx_Command =
{
    .nTx                          = 0x0,
    .nRxOk                        = 0x0,
    .nRxNok                       = 0x0,
    .nRxIgnored                   = 0x0,
    .nRxBufFull                   = 0x0,
    .lastRssi                     = 0x0,
};



