#ifndef _SMARTRF_SETTINGS_H_
#define _SMARTRF_SETTINGS_H_


//*********************************************************************************
// These settings have been generated for use with BLE SDK and CC26xx ware
//
// Generated by SmartRF Studio version 2.4.3 (build #20) and modified
// Tested for BLE SDK version 1.00.00
// Device: CC2640R2F
//
//*********************************************************************************
#ifdef DEVICE_FAMILY
    #undef DEVICE_FAMILY_PATH
    #define DEVICE_FAMILY_PATH(x) <ti/devices/DEVICE_FAMILY/x>
#else
    #error "You must define DEVICE_FAMILY at the project level as one of cc26x0, cc26x0r2, cc13x0, etc."
#endif

#include DEVICE_FAMILY_PATH(driverlib/rf_mailbox.h)
#include DEVICE_FAMILY_PATH(driverlib/rf_common_cmd.h)
#include "rf_patch_cpe_hid.h"
#include "rf_hid_cmd.h"
#include "rf_hid_mailbox.h"
#include <ti/drivers/rf/RF.h>

#define RF_NORMAL_MODE            1
#define RF_CERTIFICATE_MODE       0

// SyncWord & Address
#define TEST_SYNCWORD     0x29417472
#define TEST_ADDRESS      0xEF
#define PAIRING_SYNCWORD  0x28943447
#define PAIRING_ADDRESS   0xBD
#define GOLDEN_SYNCWORD   0x32039E16
#define GOLDEN_ADDRESS    0xDA

// RF Tx Power
#define RF_TX_POWER_MINUS_12_DBM   0x144B
#define RF_TX_POWER_MINUS_9_DBM    0x194E
#define RF_TX_POWER_MINUS_6_DBM    0x1D52
#define RF_TX_POWER_MINUS_3_DBM    0x2558
#define RF_TX_POWER_0_DBM          0x3161
#define RF_TX_POWER_1_DBM          0x4214
#define RF_TX_POWER_2_DBM          0x4E18
#define RF_TX_POWER_3_DBM          0x5A1C
#define RF_TX_POWER_4_DBM          0x9324
#define RF_TX_POWER_5_DBM          0x9330
#define OEM_RF_TX_POWER            RF_TX_POWER_5_DBM

// TI-RTOS RF HID Mode Object

extern RF_Mode RF_prop;
extern RF_Mode RF_HID;

// RF Core API commands
#if RF_NORMAL_MODE
extern rfc_CMD_HID_TX_t RF_cmdHIDTx;
extern rfc_CMD_RADIO_SETUP_t cmdHIDRadioSetup;
extern rfc_hidRxTxOutput_t output_tx_Command;
#endif
extern rfc_CMD_FS_t RF_cmdFs;
#endif // _SMARTRF_SETTINGS_H_
